//=====================================================================================
#include "gheader.h"
//=====================================================================================

#if ENABLE_UARTDEBUG_MODE	
BYTE uart_in_buf;
char u8TxdBuf[UART_TXD_BUFFER_SIZE];

#define UART1_1200			OFF
#define UART1_2400			OFF
#define UART1_4800			OFF
#define UART1_9600			OFF
#define UART1_19200			OFF
#define UART1_38400			OFF
#define UART1_57600			OFF
#define UART1_115200		ON
#define UART1_230400		OFF  //untest


#define BIT_RATE600		1
#define BIT_RATE1200	2
#define BIT_RATE2400	3
#define BIT_RATE4800	4
#define BIT_RATE9600	5
#define BIT_RATE14400	6
#define BIT_RATE19200	7
#define BIT_RATE38400	8
#define BIT_RATE57600	9
#define BIT_RATE115200	10
#define BIT_RATE230400	11

#if(UART1_1200==ON)
	#define SRG1_M	625 
	#define SRG1_F	0
#elif(UART1_2400==ON)
	#define SRG1_M	312 
	#define SRG1_F	8
#elif(UART1_4800==ON)
	#define SRG1_M	156 
	#define SRG1_F	4
#elif(UART1_9600==ON)
	#define SRG1_M	78 
	#define SRG1_F	2
#elif(UART1_19200==ON)
	#define SRG1_M	39 
	#define SRG1_F	1
#elif(UART1_38400==ON)
	#define SRG1_M	19 
	#define SRG1_F	8
#elif(UART1_57600==ON)
	#define SRG1_M	13 
	#define SRG1_F	0
#elif(UART1_115200==ON)
	#define SRG1_M	6  
	#define SRG1_F	8
#elif(UART1_230400==ON)
	#define SRG1_M	3  
	#define SRG1_F	4
#endif
#define UART0_2400			OFF		//OK	
#define UART0_9600			OFF		//OK
#define UART0_19200			OFF		//OK
#define UART0_57600			OFF		//OK
#define UART0_115200		ON		//OK
#define UART0_230400		OFF  
#define UART0_256000		OFF   // this baud rate has 0.26% error rate
#define UART0_460800		0FF  //untest

#if(UART0_2400==ON)
	#define SRG_M	312 
	#define SRG_F	8
#elif(UART0_9600==ON)
	#define SRG_M	78 
	#define SRG_F	2
#elif(UART0_19200==ON)
	#define SRG_M	39 
	#define SRG_F	1
#elif(UART0_57600==ON)
	#define SRG_M	13 
	#define SRG_F	0
#elif(UART0_115200==ON)
	#define SRG_M	6  
	#define SRG_F	8
#elif(UART0_230400==ON)		    // 0.16%
	#define SRG_M	3  
	#define SRG_F	4
#elif(UART0_256000==ON)			// 0.26%
	#define SRG_M	2  
	#define SRG_F	15
#elif(UART0_460800==ON)
	#define SRG_M	1  
	#define SRG_F	10
#endif
//=====================================================================================
//
//=====================================================================================
void DRV_Uart0Inital(void)
{
//Set baud rate 115200,n,8,1	
	SCON0 = 0x50;  //Mode1,8-bit,REN=1				
	SelectUart0Baudrate(BIT_RATE115200);
	GPB1_FUN_SLT_TX0A();	//OK



	//GPB7_FUN_SLT_RX0B();	//OK
	//GPIOC0_PIN_OE = GPIO_OUTPUT_MODE;
	#if 1
	ES = 1;
	#endif
}
void SelectUart0Baudrate(BYTE BitRateIndex)
{
	switch(BitRateIndex)
	{
		case BIT_RATE600:
			rSBRG0H = 0xCE;
			rSBRG0L = 0x20;
			break;
		case BIT_RATE1200:
			rSBRG0H = 0xA7;
			rSBRG0L = 0x10;
			break;
		case BIT_RATE2400:
			rSBRG0H = 0x93;
			rSBRG0L = 0x88;
			break;
		case BIT_RATE4800:
			rSBRG0H = 0x89;
			rSBRG0L = 0xC4;
			break;
		case BIT_RATE9600:
			rSBRG0H = 0x84;
			rSBRG0L = 0xE2;
			break;
		case BIT_RATE14400:
			rSBRG0H = 0x83;
			rSBRG0L = 0x40;
			break;
		case BIT_RATE19200:
			rSBRG0H = 0x82;
			rSBRG0L = 0x71;
			break;
		case BIT_RATE38400:
			rSBRG0H = 0x81;
			rSBRG0L = 0x38;		
			break;
		case BIT_RATE57600:
			rSBRG0H = 0x80;
			rSBRG0L = 0xD0;			
			break;
		case BIT_RATE115200:
			rSBRG0H = 0x80;
			rSBRG0L = 0x68;	
			break;
		case BIT_RATE230400:
			rSBRG0H = 0x80;
			rSBRG0L = 0x34;				
			break;
		default:
			rSBRG0H = 0x80;
			rSBRG0L = 0x68;
			break;
	}	
}





void DRV_Uart1Initial(void)
{
	//Set baud rate 115200,n,8,1 using SBRG 		
	rSCON1 = 0x50;  //Mode1,8-bit,REN=1
			
	//SelectUart1Baudrate(BIT_RATE57600);
	SelectUart1Baudrate(BIT_RATE115200);				
//Set GPIOE5 & GPIOE6 as open drian
	rGPIOE_TYP &=0x9F;	
	GPE5_FUN_SLT_RX1();		//Enable UAER 1 IO pad


	#if 0
	ES1 = 1;
	#endif
}
void SelectUart1Baudrate(BYTE BitRateIndex)
{

	switch(BitRateIndex)
	{
		case BIT_RATE600:
			rSBRG1H = 0xCE;
			rSBRG1L = 0x20;
			break;
		case BIT_RATE1200:
			rSBRG1H = 0xA7;
			rSBRG1L = 0x10;
			break;
		case BIT_RATE2400:
			rSBRG1H = 0x93;
			rSBRG1L = 0x88;
			break;
		case BIT_RATE4800:
			rSBRG1H = 0x89;
			rSBRG1L = 0xC4;
			break;
		case BIT_RATE9600:
			rSBRG1H = 0x84;
			rSBRG1L = 0xE2;
			break;
		case BIT_RATE14400:
			rSBRG1H = 0x83;
			rSBRG1L = 0x40;
			break;
		case BIT_RATE19200:
			rSBRG1H = 0x82;
			rSBRG1L = 0x71;
			break;
		case BIT_RATE38400:
			rSBRG1H = 0x81;
			rSBRG1L = 0x38;
		
			break;
		case BIT_RATE57600:
			rSBRG1H = 0x80;
			rSBRG1L = 0xD0;
			
			break;
		case BIT_RATE115200:
			rSBRG1H = 0x80;
			rSBRG1L = 0x68;	

			break;
		case BIT_RATE230400:
			rSBRG1H = 0x80;
			rSBRG1L = 0x34;	
			
			break;
		default:
			rSBRG1H = 0x80;
			rSBRG1L = 0x68;
			break;
	}

	
}

//=====================================================================================
//=====================================================================================
void API_UartDebugInitial(void)
{
	#if(UART_DEBUG_PORT==UART0)
	DRV_Uart0Inital();
	#endif
	#if(UART_DEBUG_PORT==UART1)	
	DRV_Uart1Initial();
	#endif
} 
//==============================================================================
//
//==============================================================================
void DRV_PutChar(char u8Char)
{
	//U16 u16Count=0;
	#if(UART_DEBUG_PORT==UART0)	
	SBUF0 = u8Char; 				// transfer to uart // wait transfer completing
	while(TI==0); 					// check flag
	TI = 0; 						// clear flag
	#endif

	#if(UART_DEBUG_PORT==UART1)	
	SBUF1 = u8Char; 				// transfer to uart // wait transfer completing
	while(TI_1==0); 					// check flag
	//DelayWhile(1);
	TI_1 = 0; 						// clear flag
	#endif

 
}
//==============================================================================
//
//==============================================================================
void DRV_PutStr(char *pFmt)
{
	char u8Buffer;						// Character buffer
	
	while (1)
	{
		u8Buffer = *pFmt; 			// Get a character
		if(u8Buffer == _EOS_) 	// Check end of string
			break;

		DRV_PutChar(u8Buffer); 	// Put a character
		pFmt++; 
	}
}
//==============================================================================
//
//==============================================================================
void DRV_IntToStr(U16 u16Val, U8 u8Base, char *pBuf, U8 u8Length)
{
	U8 bShowZero = FALSE;
	U16 u16Divider;
	U8 u8Disp;
	U16 u16Temp;

	u8Length -= 1;
	if(u8Base == 16)	//Hex
	{
		u16Temp = 0x01 << u8Length;
	}
	else				//Dec
	{
		u16Temp = 1;
		while(u8Length--)
		{
			u16Temp *= 10;
		}
	}
	
	if( 0 == u16Val )
	{
		/*
		pBuf[0] = '0';
		pBuf[1] = '\0';
		*/
		if( 16 == u8Base )
		{
			pBuf[0] = '0';
			pBuf[1] = '0';
			pBuf[2] = '0';
			pBuf[3] = '0';
			pBuf[4] = '\0';
		}
		else
		{
			pBuf[0] = '0';
			pBuf[1] = '0';
			pBuf[2] = '0';
			pBuf[3] = '0';
			pBuf[4] = '0';
			pBuf[5] = '\0';
		}
		return;
	}
	
	if( 16 == u8Base )
	{
		u16Divider = 0x1000;
	}	
	else
	{
		u16Divider = 10000;
	}
	
	while( u16Divider )
	{
		u8Disp = u16Val / u16Divider;
		u16Val = u16Val % u16Divider;

		//if( ucDisp )
		if(u16Temp == u16Divider)
		{
			bShowZero = TRUE;
		}
		//if( u8Disp || bShowZero)
		if( u8Disp || bShowZero || (u16Divider>0))
		{
			if( u8Disp < 10 )
				*pBuf = '0' + u8Disp;
			else
				*pBuf = 'A' + u8Disp - 10;
			pBuf ++;
		}

		if( 16 == u8Base )
		{
			u16Divider /= 0x10;
			if(bShowZero)
				u16Temp /= 0x10;
		}
		else
		{
			u16Divider /= 10;
			if(bShowZero)
				u16Temp /= 10;
		}
	}
	*pBuf = '\0';

}
//==============================================================================
//Ex:
//DRV_Printf("Hex = %x\n",0xAA55);
//DRV_Printf("Dec = %d\n",1234);
//==============================================================================
void DRV_Printf(char *pFmt, U16 u16Val)
{
	char u8Buffer;

	while(u8Buffer =(U8)*(pFmt++))
	{
		if(u8Buffer == '%') // check special case
		{
			switch(*(pFmt++)) // check next character
			{
				case 'x': // hexadecimal number
				case 'X':
					DRV_IntToStr(u16Val, 16, u8TxdBuf, 2);
					DRV_PutStr(u8TxdBuf);
				break;
				case 'd': // decimal number
				case 'i':
					DRV_IntToStr(u16Val, 10, u8TxdBuf,5);
					DRV_PutStr(u8TxdBuf);
				break;
				case 'c':
				case 'C':
					DRV_PutChar((char)u16Val);
				break;
			} // switch
		}
		else // general
		{
			DRV_PutChar(u8Buffer); // put a character
		}	
	} // while
}


//=====================================================================================
//UART0 Vector 0x23H
//=====================================================================================
void UART0_interrupt (void) interrupt 4 
{
	if(RI) 
	{			
		uart_in_buf = SBUF0;
		RI=0;		
	}
}
#endif
