//=====================================================================================
#include "gheader.h"
#include <string.h>	
#include <stdio.h>
//=====================================================================================
//For Timer0  
bdata bit Timer0Flag;
BYTE OS_Timer_Flag, OS_Timer_cnt;
//====================================================================================
//using ram
idata BYTE InDirectData1;
//====================================================================================
//using xram
xdata BYTE BackupA ;
//=====================================================================================


BYTE LedIndex1=0;
BYTE LedIndex2=0;
WORD Channel8Value=0;
BYTE DisplaySpeedCounter=0;

bdata bit WatchTimerFlag=0;
U8 xdata gbLEDFlashTime=0;
U8 xdata gbLEDStatus=0;
WORD AdcValue;
void main(void)	using 0
{
	//enable RC calibration
	//This instruction for MP chip, Do 't Remove.
	rRC_CALIB_EN = 0x80;	
	rSOURCE_CLK_SLT = 0xA0;			//select internal RC 12MHZ 	
	rSYS_CTL &=~0x80;				//Enable reset have digital filter
	rLVD_CTL = 0x00;				//don't remove this; enable LVD[2.0V] & LVDR[2.0V], to stable power consumption	// MP-chip(A)	@2012-0709

	BackupA = rSOURCE_CLK_SLT;
	rWDT_CTL |=0xA0;				//Disable watch dog	
	//Dn]w~AɭPLkN
	//iHbCpower on resetAWUisp erase command
	//{OKAiHDELAY
	DelayWhile(2000);
	
 	SYS_InitialPort();				//Set WT56F216 GPIO In/Output
	DRV_InitPowerOn();			    //Set WT56F216 Special function
	//WT56F216 Source clock select internal 12MHZ and Enable Ext 32K to calibration
	//SelectMicroSourceClock(IRC_12M);
	//WT56F216 Source clock select external 32KHZ and disable Ext 12MHz 
	SelectMicroSourceClock(EXT_12M);

	rWDT_CTL |=0xA0;				//Disable watch dog

	InDirectData1 = 0x05;
	BackupA = 0;

	//If turn on external reset pin function, please check SWUT-ISP jumper
	if(EXTERNAL_RESET==ON)
	{
		GPIOF3_PIN_OE = GPIO_INPUT_MODE;
		GPIOF3_PIN_PHN = GPIO_PULL_HIGH;
		GPF3_FUN_SLT_NRST();
	}

	
   	
   	OS_WD_FUN_DIS();

	API_LedGpioInitial();
	API_WatchTimerInitial();

	EA = 1;

	#if ENABLE_UARTDEBUG_MODE
	API_UartDebugInitial();
	//=======================================================
	DRV_PutStr("WT56F216 Load Rosc 12MHZ OK \r\n");
	DRV_PutStr("WT56F216 Set GPIO OK \r\n");
	//DRV_Printf("Last rWATCHDOG = %x \r\n",gbSystemWdtState);
	DRV_Printf("WT56F216 Firmware Version = %x \r\n",FIRMWARE_VERSION);	
	#endif


	while(1)
	{
		Timer0Service();
		if(gpio_timer_flag==1)
		{	
			gpio_timer_flag = 0;

		}

		if(adc_timer_flag==1)
		{
			adc_timer_flag = 0;			
			//Read ADC8 voltage then set watch timer eight step
			//polling ADC channel 8 /GPIOC0
			AdcValue =DRV_ReadAnalogChannel( ADC_CH0);	
			gbLEDFlashTime=0x10;//(BYTE)(AdcValue>>8);

		}

		if(system_timer_flag==1)
		{
			system_timer_flag = 0;
			DisplayLedGroup1();
		}

		if(WatchTimerFlag==1)
		{
			WatchTimerFlag = 0;

			//DisplayLedGroup2();
		}
		
   	}
	
}

//=====================================================================================
//

//=====================================================================================
void API_WatchTimerInitial(void)
{
	//Watch dog and Watch Timer using Ext-32K crystal
	rSYS_CTL |= 0x03;	
	rWTMR_CTL = 0x20;	//clear watch timer
	DisplaySpeedCounter = 0x03;			//Watch timer 125ms
	rWTMR_SLT = DisplaySpeedCounter;	//Watch timer 125ms
	rIE0_CTL = 0x04;	//Watch timer interrupt from INT0
	EX0 = 1;
}
//=====================================================================================
//
//=====================================================================================
void SelectMicroSourceClock(BYTE MicroClock)
{
	if(MicroClock==EXT_12M)
	{
		#if(EXTERNAL_12M == ON)
		//Ceystal GPIO set input and disable internal pull high
		//GPIOA2,GPIOA1,GPIOA5,GPIOA4
		rGPIOA_OEN &=0xC9;
		rGPIOA_PHN |=0x36;		
		//Enabel External Main crystal
		GPA2_FUN_SLT_XMIN();
		DelayWhile(10);
		//Enabel External Sub crystal
		GPA5_FUN_SLT_XSOUT();
		DelayWhile(10);	
		//Power On external 12MHZ and Power on external 32K			
		rIRC_12M_PD = 0xA0;	
		DelayWhile(10);	
		//Set main crystal drive		
		rCRY_12M_DR= 0x54;
		//Set sub crystal drive : SPEEDUP_C32K[1:0] Bit4 and Bit3
		rSYS_CTL |= 0x10;	 
		DelayWhile(10);
		rSOURCE_CLK_SLT = 0xA4;			//select external 12MHZ 
		DelayWhile(10);
		#endif
	}

	if(MicroClock==IRC_12M)
	{
		#if(EXTERNAL_32K == ON)
		//Ceystal GPIO set input and disable internal pull high
		//GPIOA2,GPIOA1,GPIOA5,GPIOA4
		rGPIOA_OEN &=0xC9;
		rGPIOA_PHN |=0x36;
		//Enabel External Main crystal
		//GPA2_FUN_SLT_XMIN();
		//DelayWhile(10);	
		//Enabel External Sub crystal	
		GPA5_FUN_SLT_XSOUT();
		DelayWhile(10);	
		//Power On external 32.768KHZ and Power off external 12MHz			
		rIRC_12M_PD = 0xA2;	
		DelayWhile(10);			
		//Set main crystal drive		
		//rCRY_12M_DR= 0x54;
		//Set sub crystal drive : SPEEDUP_C32K[1:0] Bit4 and Bit3
		rSYS_CTL |= 0x10;	
		DelayWhile(10);
		rSOURCE_CLK_SLT = 0xA0;			//select internal 12MHZ 
		DelayWhile(10);
		

		//Disbale Auto Calibration : because MCU need check crystal have action.
		//Enable manual Calibration
		//Selftest GPIOB7 output MCU clock		
		//rIRC_CTL |= 0x02;
		//enable RC calibration
		//DRV_EnableAutoCalibrationRC();

		//enable RC calibration for manual calibration
		rRC_CALIB_EN = 0x80;	
		#endif
	}
}
//=====================================================================================
//
//=====================================================================================
#if 0
void DRV_EnableAutoCalibrationRC(void)
{
BYTE CrystalBuf;
BYTE WatchTimerBuf1;
BYTE WatchTimerBuf2;
BYTE CrystalEventCounter=0,i;
	//Push XFR 0x01
	CrystalBuf = rSYS_CTL;
	//Push XFR 0x7C and 0x7D
	WatchTimerBuf1 = rWTMR_CTL;
	WatchTimerBuf2 = rWTMR_SLT;

	//Disable Watch Timer
	rWTMR_CTL = 0x80;
	//Set Watch Timer using External 32K
	rSYS_CTL |=0x01;
	//Set Watch Timer 3.91ms
	rWTMR_SLT = 0x00;
	//Enabel Watch Timer and clear Watch Timer Event
	rWTMR_CTL = 0x20;

	for(i=0;i<50;i++)
	{
		//Wait 10ms
		DelayWhile(10);
		if(rWTMR_CTL & 0x40)
		{
			//Clear Watch Timer Event
			rWTMR_CTL = 0x20;
			CrystalEventCounter++;				
		}

	}
	if(CrystalEventCounter>1)
	{
		//Enable H/W auto calibration
		rRC_CALIB_EN = 0xA0;
	}


	//Disable Watch Timer adn Clear Watch Timer Event
	rWTMR_CTL = 0xA0;


	//Pop XFR 0x01
	rSYS_CTL = CrystalBuf;
	//Pop XFR 0x7C and 0x7D
	rWTMR_CTL = WatchTimerBuf1;
	rWTMR_SLT = WatchTimerBuf2;
}
#endif
//=====================================================================================
//
//=====================================================================================
void SYS_InitialPort(void)
{
	rGPIOA_OEN = 0x00;
	rGPIOB_OEN = 0x55;
	rGPIOC_OEN = 0x00;
	rGPIOD_OEN = 0x00;
	rGPIOE_OEN = 0x00;
	rGPIOF_OEN = 0x00;
	// Set GPIOF3/Reset Pin as input pull high
	rGPIOF_PHN = rGPIOF_PHN & 0xF7;

	rGPIOA_FUN1 = 0;
	rGPIOA_FUN2 = 0;
	rGPIOB_FUN1 = 0;
	rGPIOB_FUN2 = 0;
	rGPIOC_FUN1 = 0;
	rGPIOC_FUN2 = 0;
	rGPIOD_FUN1 = 0;
	rGPIOD_FUN2 = 0;
	rGPIOE_FUN1 = 0;
	rGPIOE_FUN2 = 0;
	rGPIOF_FUN1 = 0;

}





//=====================================================================================
//=====================================================================================
void DRV_InitPowerOn(void)
{


	Init_OS_Timer0();			//Set Timer0 10ms




	 //Init Watchdog
#if (ACTIVE_WD_TIMER == ON)
  OS_WD_FUN_DIS();
  OS_WD_FUN_2SEC();
#else
  OS_WD_FUN_DIS();
#endif

	
		 
	DRV_AnalogKeyInitial();
	

	

}
//=====================================================================================
//define Timer0 jump to 0x9400
//=====================================================================================
void Init_OS_Timer0(void)
{
	
TR0 = 0; 
TMOD |= 0x01;
TL0 = (65536 - OS_TIMER0_BASE) % 256;         				// Set timer value for 10ms interrupt.
TH0 = (65536 - OS_TIMER0_BASE) / 256;								// 	 

	
TR0=1;
ET0 = 1; 
OS_Timer_cnt = 0;
OS_Timer_Flag = 0;

Timer0Flag = 0;
}

void Timer0 (void) interrupt 1 
{
TR0 = 0;
TL0 = (65536 - OS_TIMER0_BASE) % 256;         				// Set timer value for 10ms interrupt.
TH0 = (65536 - OS_TIMER0_BASE) / 256;					
TR0 = 1;	
Timer0Flag = 1;
	
}

void Timer0Service(void)
{
if(Timer0Flag==0) return;
Timer0Flag = 0;
OS_Timer_cnt++;
	
	if(((OS_Timer_cnt / GPIO_POLL_TIME) > 0)
  	&& ((OS_Timer_cnt % GPIO_POLL_TIME) == 0))
  	{
    gpio_timer_flag = 1;
  	}


	if(((OS_Timer_cnt / DKEY_POLL_TIME) > 0)
  	&& ((OS_Timer_cnt % DKEY_POLL_TIME) == 0))
  	{
    keypad_timer_flag = 1;
  	}
	if(((OS_Timer_cnt / ADC_POLL_TIME) > 0)
  	&& ((OS_Timer_cnt % ADC_POLL_TIME) == 0))
  	{
    	adc_timer_flag = 1;
  	}


	if(((OS_Timer_cnt / RTC_POLL_TIME) > 0)
  	&& ((OS_Timer_cnt % RTC_POLL_TIME) == 0))
  	{
    	alarm_timer_flag = 1;
  	}		
	if(((OS_Timer_cnt / DISPLAY_POLL_TIME) > 0)
  	&& ((OS_Timer_cnt % DISPLAY_POLL_TIME) == 0))
  	{
    	display_timer_flag = 1;
  	}	

	if(((OS_Timer_cnt /gbLEDFlashTime ) > 0)
  	&& ((OS_Timer_cnt % gbLEDFlashTime) == 0))
  	{
    	system_timer_flag = 1;
  	}
 


}




//=====================================================================================
//
//2012/09/10 fine tune, test 50msB100msB200ms OK.
//=====================================================================================                                                                                   

void DelayWhile(WORD  ms)		                                                  
{                                                                                         
  WORD i, j;                                                                             
                                                                                          
  for(i = 0; i < ms; i++)                                                           
  { 
	for(j = 0; j < 300; j++)	                      
    {                                                                                     
      	_nop_();  	//01				                                                                         
      	_nop_();	//02                                                                            
      	_nop_(); 	//03                                                                           
      	_nop_(); 	//04                                                                           
      	_nop_(); 	//05                                                                           
	  	_nop_(); 	//06                                                         
      	_nop_(); 	//07                                                                           
	  	_nop_();  	//08                                                        
     	_nop_();  	//09                                                                          
		_nop_();  	//10                                                        
      	_nop_(); 	//11                                                                           
		_nop_(); 	//12                                                         
     	_nop_(); 	//13
     	_nop_();	//14 		
     	_nop_(); 	//15    						                                                                         
    }                                                                                     
  }                                                                                       
} 
//=====================================================================================
//
//=====================================================================================
                                                                             
