#ifndef OS_H
#define OS_H
		
#define	Enable				1
#define	Disable				0



//==========================================================

//OS timer
#define OS_TIMER0_1MS             (WORD)(0.001/(12.0/(float)SYS_XTAL))			//Timer0 run 12T
#define OS_TIMER0_BASE            10*OS_TIMER0_1MS   //10ms



//=====================================================================================
//Power manage Control data
#define End_of_SubAddr_Table     (BYTE code *)0
//Host command
#define	FIRMWARE_VERSION		 0x01		// 2012/03/01	
//=====================================================================================
#define HOST_CMD_NULL            0xFF
#define HOST_CMD_PWRDOWN         0x00
//=====================================================================================


//OS timer flag
#define system_timer_flag        DefineBit(OS_Timer_Flag, bit0)
#define keypad_timer_flag        DefineBit(OS_Timer_Flag, bit1)
#define ir_timer_flag            DefineBit(OS_Timer_Flag, bit2)
#define adc_timer_flag            DefineBit(OS_Timer_Flag, bit3)
#define alarm_timer_flag         DefineBit(OS_Timer_Flag, bit4)


#define display_timer_flag		DefineBit(OS_Timer_Flag, bit6)
#define gpio_timer_flag         DefineBit(OS_Timer_Flag, bit7)


extern U8 xdata gbLEDStatus;
extern U8 xdata gbLEDFlashTime;

//=====================================================================================
//=====================================================================================

enum
{
  WD_RST_TIME_16MS=0x00,		//default value
  WD_RST_TIME_32MS,
  WD_RST_TIME_1S,
  WD_RST_TIME_2S,
};
//=====================================================================================
#define ACTIVE_WD_TIMER 		ON
#define OS_WD_FUN_DIS()         {rWDT_CTL |=0xA0;}   //Disable Watchdog function
#define OS_WD_FUN_2SEC()        {rWDT_CTL = WD_RST_TIME_2S ;}

//=====================================================================================

#define GPIOF3_PIN   	    DefineBit(rGPIOF_DAT, bit3)
#define GPIOF3_PIN_OE       DefineBit(rGPIOF_OEN, bit3)
#define GPIOF3_PIN_PHN      DefineBit(rGPIOF_PHN, bit3)	



#define GPIOF2_PIN   	    DefineBit(rGPIOF_DAT, bit2)
#define GPIOF2_PIN_OE       DefineBit(rGPIOF_OEN, bit2)
#define GPIOF2_PIN_PHN      DefineBit(rGPIOF_PHN, bit2)	

#define GPIOF1_PIN   	    DefineBit(rGPIOF_DAT, bit1)
#define GPIOF1_PIN_OE       DefineBit(rGPIOF_OEN, bit1)
#define GPIOF1_PIN_PHN      DefineBit(rGPIOF_PHN, bit1)	

#define GPIOF0_PIN   	    DefineBit(rGPIOF_DAT, bit0)
#define GPIOF0_PIN_OE       DefineBit(rGPIOF_OEN, bit0)
#define GPIOF0_PIN_PHN      DefineBit(rGPIOF_PHN, bit0)	

#define GPIOE7_PIN   	    DefineBit(rGPIOE_DAT, bit7)
#define GPIOE7_PIN_OE       DefineBit(rGPIOE_OEN, bit7)
#define GPIOE7_PIN_PHN      DefineBit(rGPIOE_PHN, bit7)	



#define GPIOB7_PIN   	    DefineBit(rGPIOB_DAT, bit7)
#define GPIOB7_PIN_OE       DefineBit(rGPIOB_OEN, bit7)
#define GPIOB7_PIN_PHN      DefineBit(rGPIOB_PHN, bit7)	
#define GPIOB6_PIN   	    DefineBit(rGPIOB_DAT, bit6)
#define GPIOB6_PIN_OE       DefineBit(rGPIOB_OEN, bit6)
#define GPIOB6_PIN_PHN      DefineBit(rGPIOB_PHN, bit6)
#define GPIOB5_PIN   	    DefineBit(rGPIOB_DAT, bit5)
#define GPIOB5_PIN_OE       DefineBit(rGPIOB_OEN, bit5)
#define GPIOB5_PIN_PHN      DefineBit(rGPIOB_PHN, bit5)
#define GPIOB1_PIN   	    DefineBit(rGPIOB_DAT, bit1)
#define GPIOB1_PIN_OE       DefineBit(rGPIOB_OEN, bit1)
#define GPIOB1_PIN_PHN      DefineBit(rGPIOB_PHN, bit1)


#define GPIOA5_PIN   	    DefineBit(rGPIOA_DAT, bit5)
#define GPIOA5_PIN_OE       DefineBit(rGPIOA_OEN, bit5)
#define GPIOA5_PIN_PHN      DefineBit(rGPIOA_PHN, bit5)

#define GPIOA4_PIN   	    DefineBit(rGPIOA_DAT, bit4)
#define GPIOA4_PIN_OE       DefineBit(rGPIOA_OEN, bit4)
#define GPIOA4_PIN_PHN      DefineBit(rGPIOA_PHN, bit4)

#define GPIOA2_PIN   	    DefineBit(rGPIOA_DAT, bit2)
#define GPIOA2_PIN_OE       DefineBit(rGPIOA_OEN, bit2)
#define GPIOA2_PIN_PHN      DefineBit(rGPIOA_PHN, bit2)
#define GPIOA1_PIN   	    DefineBit(rGPIOA_DAT, bit1)
#define GPIOA1_PIN_OE       DefineBit(rGPIOA_OEN, bit1)
#define GPIOA1_PIN_PHN      DefineBit(rGPIOA_PHN, bit1)
//=====================================================================================
//=====================================================================================

extern bdata bit WatchTimerFlag;
void API_WatchTimerInitial(void);
void SYS_InitialPort(void);
void SelectMicroSourceClock(BYTE ClockIndex);
#if 0
void DRV_EnableAutoCalibrationRC(void);
#endif
void Init_OS_Timer0(void);
void Timer0Service(void);
void DRV_InitPowerOn(void);
void DelayWhile(WORD  ms);




extern BYTE LedIndex1;
extern BYTE LedIndex2;
//=====================================================================================
#endif