// REG_WT56F248_MemAlloc.h 
// Version: 1.00 >>@2013-12-27, First                                                                     
//---------------------------------------
// XFR ---- using xdata
//---------------------------------------
#if(XFR_USEING==XDATA_FOR_XFR)
// System Level Register
extern xdata BYTE rCHIP_ID;			//_at_ 0x0000;  // R
extern xdata BYTE rSYS_CTL;      	//_at_ 0x0001;  // RW
extern xdata BYTE rLVD_CTL;      	//_at_ 0x0002;  // RW
extern xdata BYTE rRESET_FLG;     	//_at_ 0x0003;  // RW

// power saving
extern xdata BYTE rISP_CHG_CTL;		//_at_ 0x0004;  // RW
extern xdata BYTE rSOURCE_CLK_SLT;	//_at_ 0x0005;  // RW
extern xdata BYTE rCLOCK_SW_CTL;	//_at_ 0x0006;  // RW
extern xdata BYTE rIRC_12M_PD;		//_at_ 0x0007;  // RW
extern xdata BYTE rCRY_12M_DR;     	//_at_ 0x0008;  // RW
#define rPOWER_SAVE_CTL rCLOCK_SW_CTL

extern xdata BYTE rPATH_SLT;		// 0x000B

extern xdata BYTE rCSTM_ID1;       	//_at_ 0x000D;  // RW
extern xdata BYTE rCSTM_ID2;       	//_at_ 0x000E;  // RW
extern xdata BYTE rCSTM_ID3;       	//_at_ 0x000F;  // RW

// GPIO
extern xdata BYTE rGPIOA_OEN;     	//_at_ 0x0010;  // RW
extern xdata BYTE rGPIOB_OEN;     	//_at_ 0x0011;  // RW
extern xdata BYTE rGPIOC_OEN;     	//_at_ 0x0012;  // RW 
extern xdata BYTE rGPIOD_OEN;     	//_at_ 0x0013;  // RW 
extern xdata BYTE rGPIOE_OEN;     	//_at_ 0x0014;  // RW 
extern xdata BYTE rGPIOF_OEN;     	//_at_ 0x0015;  // RW 

extern xdata BYTE rGPIOA_DAT;     	//_at_ 0x0016;  // RW
extern xdata BYTE rGPIOB_DAT;     	//_at_ 0x0017;  // RW
extern xdata BYTE rGPIOC_DAT;     	//_at_ 0x0018;  // RW 
extern xdata BYTE rGPIOD_DAT;     	//_at_ 0x0019;  // RW 
extern xdata BYTE rGPIOE_DAT;     	//_at_ 0x001A;  // RW 
extern xdata BYTE rGPIOF_DAT;    	//_at_ 0x001B;  // RW 

extern xdata BYTE rGPIOA_PHN;     	//_at_ 0x001C;  // RW
extern xdata BYTE rGPIOB_PHN;     	//_at_ 0x001D;  // RW
extern xdata BYTE rGPIOC_PHN;     	//_at_ 0x001E;  // RW
extern xdata BYTE rGPIOD_PHN;     	//_at_ 0x001F;  // RW
extern xdata BYTE rGPIOE_PHN;     	//_at_ 0x0020;  // RW
extern xdata BYTE rGPIOF_PHN;     	//_at_ 0x0021;  // RW

extern xdata BYTE rGPIOA_TYP;     	//_at_ 0x0022;  // RW
extern xdata BYTE rGPIOE_TYP;     	//_at_ 0x0023;  // RW
extern xdata BYTE rGPIOF_TYP;		//_at_ 0x0024;  // RW

extern xdata BYTE rGPIOA_FUN1;		//_at_ 0x0025;  // RW 
extern xdata BYTE rGPIOA_FUN2;     	//_at_ 0x0026;  // RW		 
extern xdata BYTE rGPIOB_FUN1;      //_at_ 0x0027;  // RW		
extern xdata BYTE rGPIOB_FUN2;      //_at_ 0x0028;  // RW
extern xdata BYTE rGPIOC_FUN1;      //_at_ 0x0029;  // RW
extern xdata BYTE rGPIOC_FUN2;      //_at_ 0x002A;  // RW
extern xdata BYTE rGPIOD_FUN1;     	//_at_ 0x002B;  // RW
extern xdata BYTE rGPIOD_FUN2;     	//_at_ 0x002C;  // RW
extern xdata BYTE rGPIOE_FUN1;      //_at_ 0x002D;  // RW
extern xdata BYTE rGPIOE_FUN2;      //_at_ 0x002E;  // RW
extern xdata BYTE rGPIOF_FUN1;      //_at_ 0x002F;  // RW
      
         

// 8051 Int-0/1/2/3
extern xdata BYTE rIE0_CTL;    		//_at_ 0x0030;  // RW
extern xdata BYTE rIE1_CTL;    		//_at_ 0x0031;  // RW
extern xdata BYTE rIE2_CTL;    		//_at_ 0x0032;  // RW
extern xdata BYTE rIE3_IRQH;   		//_at_ 0x0033;  // RW
extern xdata BYTE rIE3_IRQL;   		//_at_ 0x0034;  // RW
extern xdata BYTE rIF0_FLAG;   		//_at_ 0x0035;  // RW
extern xdata BYTE rIF1_FLAG;   		//_at_ 0x0036;  // RW
extern xdata BYTE rIF2_FLAG;   		//_at_ 0x0037;  // RW
extern xdata BYTE rIF3_IRQH;   		//_at_ 0x0038;  // RW
extern xdata BYTE rIF3_IRQL;		//_at_ 0x0039;  // RW

// IRQ
extern xdata BYTE rEN_IRQH;	    	//_at_ 0x0040;  // RW
extern xdata BYTE rEN_IRQL;	 		//_at_ 0x0041;  // RW
extern xdata BYTE rEVT_IRQH;     	//_at_ 0x0042;  // RW
extern xdata BYTE rEVT_IRQL;   		//_at_ 0x0043;  // RW
extern xdata BYTE rCLR_IRQH;		//_at_ 0x0044;  // RW
extern xdata BYTE rCLR_IRQL;     	//_at_ 0x0045;  // RW
extern xdata BYTE rIRQ_CHGH;     	//_at_ 0x0046;  // RW
extern xdata BYTE rIRQ_CHGL;     	//_at_ 0x0047;  // RW
extern xdata BYTE rIRQ_EDGEH;    	//_at_ 0x0048;  // RW
extern xdata BYTE rIRQ_EDGEL;    	//_at_ 0x0049;  // RW

// PWM
extern xdata BYTE rPWM_CTL;        	//_at_ 0x0050;  // RW
extern xdata BYTE rPWM0_PRDH;      	//_at_ 0x0051;  // RW 
extern xdata BYTE rPWM0_PRDL;		//_at_ 0x0052;  // RW
extern xdata BYTE rPWM0_DUTYH;     	//_at_ 0x0053;  // RW 
extern xdata BYTE rPWM0_DUTYL;     	//_at_ 0x0054;  // RW
extern xdata BYTE rPWM1_PRDH;      	//_at_ 0x0055;  // RW 
extern xdata BYTE rPWM1_PRDL;      	//_at_ 0x0056;  // RW
extern xdata BYTE rPWM1_DUTYH;     	//_at_ 0x0057;  // RW 
extern xdata BYTE rPWM1_DUTYL;     	//_at_ 0x0058;  // RW

extern xdata BYTE rPWM_CTL1;		//_at_ 0x005A;
extern xdata BYTE rPWM_CTL2;		//_at_ 0x005B;
extern xdata BYTE rPWM2_PRDH;	//_at_ 0x005C;
extern xdata BYTE rPWM2_PRDL;	//_at_ 0x005D;
extern xdata BYTE rPWM2_DUTYH;	//_at_ 0x005E;
extern xdata BYTE rPWM2_DUTYL;	//_at_ 0x005F;
extern xdata BYTE rPWM3_PRDH;	//_at_ 0x0250;
extern xdata BYTE rPWM3_PRDL;	//_at_ 0x0251;
extern xdata BYTE rPWM3_DUTYH;	//_at_ 0x0252;
extern xdata BYTE rPWM3_DUTYL;	//_at_ 0x0253;
extern xdata BYTE rPWM4_PRDH;	//_at_ 0x0254;
extern xdata BYTE rPWM4_PRDL;	//_at_ 0x0255;
extern xdata BYTE rPWM4_DUTYH;	//_at_ 0x0256;
extern xdata BYTE rPWM4_DUTYL;	//_at_ 0x0257;
extern xdata BYTE rPWM5_PRDH;	//_at_ 0x0258;
extern xdata BYTE rPWM5_PRDL;	//_at_ 0x0259;
extern xdata BYTE rPWM5_DUTYH;	//_at_ 0x025A;
extern xdata BYTE rPWM5_DUTYL;	//_at_ 0x025B;

// wakeup & Toggle
extern xdata BYTE rGPIOA_WK;       	//_at_ 0x0060;  // RW
extern xdata BYTE rGPIOB_WK;       	//_at_ 0x0061;  // RW
extern xdata BYTE rGPIOE_WK;       	//_at_ 0x0062;  // RW
extern xdata BYTE rGPIOF_WK;       	//_at_ 0x0063;  // RW
extern xdata BYTE rPERIPHERAL_WK;	//_at_ 0x0064;  // RW
extern xdata BYTE rGPIOA_TOG;      	//_at_ 0x0065;  // R
extern xdata BYTE rGPIOB_TOG;      	//_at_ 0x0066;  // R
extern xdata BYTE rGPIOE_TOG;      	//_at_ 0x0067;  // R
extern xdata BYTE rGPIOF_TOG;      	//_at_ 0x0068;  // R
extern xdata BYTE rPERIPHERAL_TOG; 	//_at_ 0x0069;  // R
extern xdata BYTE rCLR_IN_TOG;     	//_at_ 0x006A;  // RW

// IRC calibration
extern xdata BYTE rRC_LADJ;			//_at_ 0x0070;  // RW
extern xdata BYTE rRC12M_CNTH;		//_at_ 0x0071;  // RW
extern xdata BYTE rRC12M_CNTL;		//_at_ 0x0072;  // RW
extern xdata BYTE rRC_CALIB_EN;		//_at_ 0x0073;  // RW

extern xdata BYTE RC_CALIB_EN1;		//_at_ 0x0074;

// WDT
extern xdata BYTE rWDT_CTL;			//_at_ 0x0078;  // RW

// WATCH Timer
extern xdata BYTE rWTMR_CTL;		//_at_ 0x007C;  // RW
extern xdata BYTE rWTMR_SLT;		//_at_ 0x007D;  // RW

//LCD Driver
//LCDܸƼȦs 0-19
extern xdata BYTE rLCD_DAT0;   		//_at_ 0x0080;  // RW
extern xdata BYTE rLCD_DAT1;   		//_at_ 0x0081;  // RW
extern xdata BYTE rLCD_DAT2;   		//_at_ 0x0082;  // RW
extern xdata BYTE rLCD_DAT3;   		//_at_ 0x0083;  // RW
extern xdata BYTE rLCD_DAT4;   		//_at_ 0x0084;  // RW
extern xdata BYTE rLCD_DAT5;   		//_at_ 0x0085;  // RW
extern xdata BYTE rLCD_DAT6;   		//_at_ 0x0086;  // RW
extern xdata BYTE rLCD_DAT7;   		//_at_ 0x0087;  // RW
extern xdata BYTE rLCD_DAT8;   		//_at_ 0x0088;  // RW
extern xdata BYTE rLCD_DAT9;   		//_at_ 0x0089;  // RW
extern xdata BYTE rLCD_DAT10;   	//_at_ 0x008A;  // RW
extern xdata BYTE rLCD_DAT11;   	//_at_ 0x008B;  // RW
extern xdata BYTE rLCD_DAT12;   	//_at_ 0x008C;  // RW
extern xdata BYTE rLCD_DAT13;   	//_at_ 0x008D;  // RW
extern xdata BYTE rLCD_DAT14;   	//_at_ 0x008E;  // RW
extern xdata BYTE rLCD_DAT15;   	//_at_ 0x008F;  // RW
extern xdata BYTE rLCD_DAT16;   	//_at_ 0x0090;  // RW
extern xdata BYTE rLCD_DAT17;   	//_at_ 0x0091;  // RW
extern xdata BYTE rLCD_DAT18;   	//_at_ 0x0092;  // RW
extern xdata BYTE rLCD_DAT19;		//_at_ 0x0093;  // RW




// LCD Control Register 1 
extern xdata BYTE rLCD_CTL1;		//_at_ 0x0098;  // W
extern xdata BYTE rLCD_CTL2;   		//_at_ 0x0099;  // R
extern xdata BYTE rLCD_CVLS;		//_at_ 0x009A;  // R
extern xdata BYTE rLCD_PSC;    		//_at_ 0x009B;  // RW
extern xdata BYTE rSEG_EN0;    		//_at_ 0x009C;  // RW
extern xdata BYTE rSEG_EN1;   	 	//_at_ 0x009D;  // RW
extern xdata BYTE rSEG_EN2;    		//_at_ 0x009E;  // RW




// Master/Slave I2C Interface
extern xdata BYTE rMI2C_CTL;       	//_at_ 0x00A0;  // RW
extern xdata BYTE rMI2C_STA;       	//_at_ 0x00A1;  // RW
extern xdata BYTE rMI2C_DSLV;      	//_at_ 0x00A2;  // RW
extern xdata BYTE rMI2C_DTRX;      	//_at_ 0x00A3;  // R
extern xdata BYTE rMI2C_SADR;      	//_at_ 0x00A4;  // RW
extern xdata BYTE rMI2C_EXTEND;    	//_at_ 0x00A5;  // RW

// enhance Timer
extern xdata BYTE rETM_CTL1;       	//_at_ 0x00B0;  // RW
extern xdata BYTE rETM_CTL2;       	//_at_ 0x00B1;  // RW
extern xdata BYTE rETM_INT;        	//_at_ 0x00B2;  // RW
extern xdata BYTE rETM_BUFL;       	//_at_ 0x00B3;  // RW
extern xdata BYTE rETM_BUFH;       	//_at_ 0x00B4;  // RW

extern xdata BYTE rETM_CTL3;		//_at_ 0x00B5;

// SPI
extern xdata BYTE rSPI_CTL1;       	//_at_ 0x00C0;  // RW
extern xdata BYTE rSPI_CTL2;       	//_at_ 0x00C1;  // RW
extern xdata BYTE rSPI_INT;       	//_at_ 0x00C2;  // RW
extern xdata BYTE rSPI_CLR;      	//_at_ 0x00C3;  // RW
extern xdata BYTE rSPI_FLG;      	//_at_ 0x00C4;  // RW
extern xdata BYTE rSPI_BRS;     	//_at_ 0x00C5;  // RW
extern xdata BYTE rSPI_TXBUF;      	//_at_ 0x00C6;  // RW
extern xdata BYTE rSPI_RXBUF;     	//_at_ 0x00C7;  // RW
	
// Low Speed ADC (for key scan)
extern xdata BYTE rADC_CTL;       	//_at_ 0x00D0;  // RW
extern xdata BYTE rADC_SEL;     	//_at_ 0x00D1;  // R
extern xdata BYTE rADC_INT;      	//_at_ 0x00D2;  // RW
extern xdata BYTE rADC_ENCH;       	//_at_ 0x00D3;  // RW
extern xdata BYTE rADC_CMP_VH;     	//_at_ 0x00D4;  // R
extern xdata BYTE rADC_CMP_VL;      //_at_ 0x00D5;  // RW
extern xdata BYTE rADC_DATAH;      	//_at_ 0x00D6;  // RW
extern xdata BYTE rADC_DATAL;      	//_at_ 0x00D7;  // RW

// Ananlog Comparator
extern xdata BYTE rACOMP_CTL;      	//_at_ 0x00DA;  // RW 
extern xdata BYTE rACOMP_FLG;      	//_at_ 0x00DB;  // RW 
extern xdata BYTE rACOMP_VREF;      //_at_ 0x00DC;  // RW 
extern xdata BYTE rACOMP_IOCTL;     	//_at_ 0x00DD;  // RW
//simulation EEPROM
extern xdata BYTE rEER_EN1;       	//_at_ 0x00E0;  // W
extern xdata BYTE rEER_EN2;       	//_at_ 0x00E1;  // W
extern xdata BYTE rEER_ADDRL;     	//_at_ 0x00E2;  //RW		//bit 7-0
extern xdata BYTE rEER_ADDRH;     	//_at_ 0x00E3;  //RW		//bit 11-8
extern xdata BYTE rEER_TCTL;     	//_at_ 0x00E4;	//W
extern xdata BYTE rEER_DATA;     	//_at_ 0x00E8;  // W


extern xdata BYTE rFLASH_CTL;	    //_at_ 0x00F0;  // R/W
extern xdata BYTE rIRC_CTL;		 	//_at_ 0x00F2;  // R/W

extern xdata BYTE rGPIOG_OEN;		//_at_ 0x0210;
extern xdata BYTE rGPIOG_DAT;	//_at_ 0x0211;
extern xdata BYTE rGPIOG_PHN;		//_at_ 0x0212;

extern xdata BYTE rGPIOA_FUN3;		//	_at_ 0x0221;
extern xdata BYTE rGPIOB_FUN3;		//	_at_ 0x0222;
extern xdata BYTE rGPIOB_FUN4;		//	_at_ 0x0223;
extern xdata BYTE rGPIOE_FUN3;		//	_at_ 0x0228;
extern xdata BYTE rGPIOF_FUN2;		//	_at_ 0x022B;
extern xdata BYTE rGPIOG_FUN1;		//	_at_ 0x022C;
extern xdata BYTE rGPIOG_FUN2;		//	_at_ 0x022D;	




#endif


//---------------------------------------
// XFR ---- using extern pdata
//---------------------------------------
#if(XFR_USEING==PDATA_FOR_XFR)
// System Level Register
extern pdata BYTE rCHIP_ID;       	//_at_ 0x0000;  // R
extern pdata BYTE rSYS_CTL;      	//_at_ 0x0001;  // RW
extern pdata BYTE rLVD_CTL;      	//_at_ 0x0002;  // RW
extern pdata BYTE rRESET_FLG;      	//_at_ 0x0003;  // RW

// power saving
extern pdata BYTE rISP_CHG_CTL;		//_at_ 0x0004;  // RW
extern pdata BYTE rSOURCE_CLK_SLT;	//_at_ 0x0005;  // RW
extern pdata BYTE rCLOCK_SW_CTL;	//_at_ 0x0006;  // RW
extern pdata BYTE rIRC_12M_PD;		//_at_ 0x0007;  // RW
extern pdata BYTE rCRY_12M_DR;      //_at_ 0x0008;  // RW
#define rPOWER_SAVE_CTL rCLOCK_SW_CTL
extern pdata BYTE rCSTM_ID1;       	//_at_ 0x000D;  // RW
extern pdata BYTE rCSTM_ID2;       	//_at_ 0x000E;  // RW
extern pdata BYTE rCSTM_ID3;       	//_at_ 0x000F;  // RW

// GPIO
extern pdata BYTE rGPIOA_OEN;     	//_at_ 0x0010;  // RW
extern pdata BYTE rGPIOB_OEN;     	//_at_ 0x0011;  // RW
extern pdata BYTE rGPIOC_OEN;     	//_at_ 0x0012;  // RW 
extern pdata BYTE rGPIOD_OEN;     	//_at_ 0x0013;  // RW 
extern pdata BYTE rGPIOE_OEN;     	//_at_ 0x0014;  // RW 
extern pdata BYTE rGPIOF_OEN;     	//_at_ 0x0015;  // RW 

extern pdata BYTE rGPIOA_DAT;     	//_at_ 0x0016;  // RW
extern pdata BYTE rGPIOB_DAT;     	//_at_ 0x0017;  // RW
extern pdata BYTE rGPIOC_DAT;     	//_at_ 0x0018;  // RW 
extern pdata BYTE rGPIOD_DAT;     	//_at_ 0x0019;  // RW 
extern pdata BYTE rGPIOE_DAT;     	//_at_ 0x001A;  // RW 
extern pdata BYTE rGPIOF_DAT;     	//_at_ 0x001B;  // RW 

extern pdata BYTE rGPIOA_PHN;     	//_at_ 0x001C;  // RW
extern pdata BYTE rGPIOB_PHN;     	//_at_ 0x001D;  // RW
extern pdata BYTE rGPIOC_PHN;     	//_at_ 0x001E;  // RW
extern pdata BYTE rGPIOD_PHN;     	//_at_ 0x001F;  // RW
extern pdata BYTE rGPIOE_PHN;    	//_at_ 0x0020;  // RW
extern pdata BYTE rGPIOF_PHN;    	//_at_ 0x0021;  // RW

extern pdata BYTE rGPIOA_TYP;     	//_at_ 0x0022;  // RW
extern pdata BYTE rGPIOE_TYP;     	//_at_ 0x0023;  // RW
extern pdata BYTE rGPIOF_TYP;     	//_at_ 0x0024;  // RW

extern pdata BYTE rGPIOA_FUN1;      //_at_ 0x0025;  // RW 
extern pdata BYTE rGPIOA_FUN2;     	//_at_ 0x0026;  // RW		ADC 0~7 enable io pad 
extern pdata BYTE rGPIOB_FUN1;      //_at_ 0x0027;  // RW		SCAN 0~7 enable io pad
extern pdata BYTE rGPIOB_FUN2;      //_at_ 0x0028;  // RW
extern pdata BYTE rGPIOC_FUN1;      //_at_ 0x0029;  // RW
extern pdata BYTE rGPIOC_FUN2;      //_at_ 0x002A;  // RW
extern pdata BYTE rGPIOD_FUN1;     	//_at_ 0x002B;  // RW
extern pdata BYTE rGPIOD_FUN2;     	//_at_ 0x002C;  // RW
extern pdata BYTE rGPIOE_FUN1;      //_at_ 0x002D;  // RW
extern pdata BYTE rGPIOE_FUN2;      //_at_ 0x002E;  // RW
extern pdata BYTE rGPIOF_FUN1;      //_at_ 0x002F;  // RW
         

// 8051 Int-0/1/2/3
extern pdata BYTE rIE0_CTL;     	//_at_ 0x0030;  // RW
extern pdata BYTE rIE1_CTL;     	//_at_ 0x0031;  // RW
extern pdata BYTE rIE2_CTL;     	//_at_ 0x0032;  // RW
extern pdata BYTE rIE3_IRQH;    	//_at_ 0x0033;  // RW
extern pdata BYTE rIE3_IRQL;    	//_at_ 0x0034;  // RW
extern pdata BYTE rIF0_FLAG;    	//_at_ 0x0035;  // RW
extern pdata BYTE rIF1_FLAG;    	//_at_ 0x0036;  // RW
extern pdata BYTE rIF2_FLAG;    	//_at_ 0x0037;  // RW
extern pdata BYTE rIF3_IRQH;    	//_at_ 0x0038;  // RW
extern pdata BYTE rIF3_IRQL;		//_at_ 0x0039;  // RW

// IRQ
extern pdata BYTE rEN_IRQH;	      	//_at_ 0x0040;  // RW
extern pdata BYTE rEN_IRQL;	 		//_at_ 0x0041;  // RW
extern pdata BYTE rEVT_IRQH;     	//_at_ 0x0042;  // RW
extern pdata BYTE rEVT_IRQL;    	//_at_ 0x0043;  // RW
extern pdata BYTE rCLR_IRQH;		//_at_ 0x0044;  // RW
extern pdata BYTE rCLR_IRQL;     	//_at_ 0x0045;  // RW
extern pdata BYTE rIRQ_CHGH;     	//_at_ 0x0046;  // RW
extern pdata BYTE rIRQ_CHGL;     	//_at_ 0x0047;  // RW
extern pdata BYTE rIRQ_EDGEH;     	//_at_ 0x0048;  // RW
extern pdata BYTE rIRQ_EDGEL;     	//_at_ 0x0049;  // RW

// PWM
extern pdata BYTE rPWM_CTL;         //_at_ 0x0050;  // RW
extern pdata BYTE rPWM0_PRDH;       //_at_ 0x0051;  // RW 
extern pdata BYTE rPWM0_PRDL;       //_at_ 0x0052;  // RW
extern pdata BYTE rPWM0_DUTYH;      //_at_ 0x0053;  // RW 
extern pdata BYTE rPWM0_DUTYL;      //_at_ 0x0054;  // RW
extern pdata BYTE rPWM1_PRDH;       //_at_ 0x0055;  // RW 
extern pdata BYTE rPWM1_PRDL;       //_at_ 0x0056;  // RW
extern pdata BYTE rPWM1_DUTYH;      //_at_ 0x0057;  // RW 
extern pdata BYTE rPWM1_DUTYL;      //_at_ 0x0058;  // RW


// wakeup & Toggle
extern pdata BYTE rGPIOA_WK;        //_at_ 0x0060;  // RW
extern pdata BYTE rGPIOB_WK;        //_at_ 0x0061;  // RW
extern pdata BYTE rGPIOE_WK;        //_at_ 0x0062;  // RW
extern pdata BYTE rGPIOF_WK;        //_at_ 0x0063;  // RW
extern pdata BYTE rPERIPHERAL_WK;   //_at_ 0x0064;  // RW
extern pdata BYTE rGPIOA_TOG;       //_at_ 0x0065;  // R
extern pdata BYTE rGPIOB_TOG;       //_at_ 0x0066;  // R
extern pdata BYTE rGPIOE_TOG;       //_at_ 0x0067;  // R
extern pdata BYTE rGPIOF_TOG;       //_at_ 0x0068;  // R
extern pdata BYTE rPERIPHERAL_TOG;  //_at_ 0x0069;  // R
extern pdata BYTE rCLR_IN_TOG;      //_at_ 0x006A;  // RW

// IRC calibration
extern pdata BYTE rRC_LADJ;			//_at_ 0x0070;  // RW
extern pdata BYTE rRC12M_CNTH;		//_at_ 0x0071;  // RW
extern pdata BYTE rRC12M_CNTL;		//_at_ 0x0072;  // RW
extern pdata BYTE rRC_CALIB_EN;		//_at_ 0x0073;  // RW

// WDT
extern pdata BYTE rWDT_CTL;			//_at_ 0x0078;  // RW

// WATCH Timer
extern pdata BYTE rWTMR_CTL;		//_at_ 0x007C;  // RW
extern pdata BYTE rWTMR_SLT;		//_at_ 0x007D;  // RW

//LCD Driver
//LCDܸƼȦs 0-19
extern pdata BYTE rLCD_DAT0;    	//_at_ 0x0080;  // RW
extern pdata BYTE rLCD_DAT1;    	//_at_ 0x0081;  // RW
extern pdata BYTE rLCD_DAT2;    	//_at_ 0x0082;  // RW
extern pdata BYTE rLCD_DAT3;    	//_at_ 0x0083;  // RW
extern pdata BYTE rLCD_DAT4;    	//_at_ 0x0084;  // RW
extern pdata BYTE rLCD_DAT5;    	//_at_ 0x0085;  // RW
extern pdata BYTE rLCD_DAT6;    	//_at_ 0x0086;  // RW
extern pdata BYTE rLCD_DAT7;    	//_at_ 0x0087;  // RW
extern pdata BYTE rLCD_DAT8;    	//_at_ 0x0088;  // RW
extern pdata BYTE rLCD_DAT9;    	//_at_ 0x0089;  // RW
extern pdata BYTE rLCD_DAT10;   	//_at_ 0x008A;  // RW
extern pdata BYTE rLCD_DAT11;   	//_at_ 0x008B;  // RW
extern pdata BYTE rLCD_DAT12;   	//_at_ 0x008C;  // RW
extern pdata BYTE rLCD_DAT13;   	//_at_ 0x008D;  // RW
extern pdata BYTE rLCD_DAT14;   	//_at_ 0x008E;  // RW
extern pdata BYTE rLCD_DAT15;   	//_at_ 0x008F;  // RW
extern pdata BYTE rLCD_DAT16;   	//_at_ 0x0090;  // RW
extern pdata BYTE rLCD_DAT17;  		//_at_ 0x0091;  // RW
extern pdata BYTE rLCD_DAT18;   	//_at_ 0x0092;  // RW
extern pdata BYTE rLCD_DAT19;		//_at_ 0x0093;  // RW

// LCD Control Register 1 
extern pdata BYTE rLCD_CTL1;		//_at_ 0x0098;  // W
extern pdata BYTE rLCD_CTL2;   		//_at_ 0x0099;  // R
extern pdata BYTE rLCD_CVLS;		//_at_ 0x009A;  // R
extern pdata BYTE rLCD_PSC;    		//_at_ 0x009B;  // RW
extern pdata BYTE rSEG_EN0;    		//_at_ 0x009C;  // RW
extern pdata BYTE rSEG_EN1;    		//_at_ 0x009D;  // RW
extern pdata BYTE rSEG_EN2;    		//_at_ 0x009E;  // RW


// Master/Slave I2C Interface
extern pdata BYTE rMI2C_CTL;       	//_at_ 0x00A0;  // RW
extern pdata BYTE rMI2C_STA;       	//_at_ 0x00A1;  // RW
extern pdata BYTE rMI2C_DSLV;       //_at_ 0x00A2;  // RW
extern pdata BYTE rMI2C_DTRX;       //_at_ 0x00A3;  // R
extern pdata BYTE rMI2C_SADR;      	//_at_ 0x00A4;  // RW
extern pdata BYTE rMI2C_EXTEND;     //_at_ 0x00A5;  // RW

// enhance Timer
extern pdata BYTE rETM_CTL1;       	//_at_ 0x00B0;  // RW
extern pdata BYTE rETM_CTL2;       	//_at_ 0x00B1;  // RW
extern pdata BYTE rETM_INT;       	//_at_ 0x00B2;  // RW
extern pdata BYTE rETM_BUFL;        //_at_ 0x00B3;  // RW
extern pdata BYTE rETM_BUFH;        //_at_ 0x00B4;  // RW


// SPI
extern pdata BYTE rSPI_CTL1;       	//_at_ 0x00C0;  // RW
extern pdata BYTE rSPI_CTL2;       	//_at_ 0x00C1;  // RW
extern pdata BYTE rSPI_INT;       	//_at_ 0x00C2;  // RW
extern pdata BYTE rSPI_CLR;      	//_at_ 0x00C3;  // RW
extern pdata BYTE rSPI_FLG;      	//_at_ 0x00C4;  // RW
extern pdata BYTE rSPI_BRS;     	//_at_ 0x00C5;  // RW
extern pdata BYTE rSPI_TXBUF;      	//_at_ 0x00C6;  // RW
extern pdata BYTE rSPI_RXBUF;     	//_at_ 0x00C7;  // RW

// Low Speed ADC (for key scan)
extern pdata BYTE rADC_CTL;       	//_at_ 0x00D0;  // RW
extern pdata BYTE rADC_SEL;     	//_at_ 0x00D1;  // R
extern pdata BYTE rADC_INT;      	//_at_ 0x00D2;  // RW
extern pdata BYTE rADC_ENCH;       	//_at_ 0x00D3;  // RW
extern pdata BYTE rADC_CMP_VH;     	//_at_ 0x00D4;  // R
extern pdata BYTE rADC_CMP_VL;      //_at_ 0x00D5;  // RW
extern pdata BYTE rADC_DATAH;      	//_at_ 0x00D6;  // RW
extern pdata BYTE rADC_DATAL;      	//_at_ 0x00D7;  // RW

// Ananlog Comparator
extern pdata BYTE rACOMP_CTL;      	//_at_ 0x00DA;  // RW 
extern pdata BYTE rACOMP_FLG;      	//_at_ 0x00DB;  // RW 
extern pdata BYTE rACOMP_VREF;      //_at_ 0x00DC;  // RW 
extern pdata BYTE rACOMP_IOCTL;    	//_at_ 0x00DD;  // RW
//simulation EEPROM
extern pdata BYTE rEER_EN1;       	//_at_ 0x00E0;  // W
extern pdata BYTE rEER_EN2;       	//_at_ 0x00E1;  // W
extern pdata BYTE rEER_ADDRL;     	//_at_ 0x00E2;  //RW		//bit 7-0
extern pdata BYTE rEER_ADDRH;     	//_at_ 0x00E3;  //RW		//bit 11-8
extern pdata BYTE rEER_TCTL;    	//_at_ 0x00E4;	//W
extern pdata BYTE rEER_DATA;    	//_at_ 0x00E8;  // W

#endif

extern xdata BYTE rCUSTOMER_ID;
extern xdata BYTE rINITIAL_DATA;
extern xdata BYTE rLDO_CALIBRATION_DATA;
extern xdata BYTE rRC_CALIBRATION_DATA;	
extern xdata BYTE rRC_CALIBRATION_DATA2;
//=====================================================================================



//-------------------------------
#define		rMI2C_DTX		rMI2C_DTRX
#define		rMI2C_DRX		rMI2C_DTRX
//-------------------------------

//-------------------------------
//	XFR_0xA0~0xA8, 	E-Timer
//-------------------------------

/*	
#define	MI2C_CLK_00		(0x00 << 5)	// clk = 400K
#define	MI2C_CLK_01		(0x01 << 5)	// clk = 200K
#define	MI2C_CLK_02		(0x02 << 5)	// clk = 100K
#define	MI2C_CLK_03 		(0x03 << 5)	// clk = 50K
*/
/*
#define	MI2C_RDY			( 1 << 7)	
#define	MI2C_INT_RT		( 1 << 6)	
#define	MI2C_INT_STOP		( 1 << 5)	
#define	MI2C_BB			( 1 << 4)	
#define	MI2C_FIRST			( 1 << 3)	
#define	MI2C_RW			( 1 << 2)	
#define	MI2C_RXNAK			( 1 << 1)
#define	MI2C_SLVE			( 1 << 0)		// [0/1]: MASTER/ SLAVER MODE
*/
//#define	MI2C_AUTOSTP		( 1 << 1)	
//#define	MI2C_WAIT			( 1 << 0)	
