#ifndef INTERRUPT_H
#define INTERRUPT_H
//=====================================================================================
/*
#define		IF_IRQ15		0x80
#define		IF_IRQ14		0x40
#define		IF_IRQ13		0x20
#define		IF_IRQ12		0x10
#define		IF_IRQ11		0x08
#define		IF_IRQ10		0x04
#define		IF_IRQ9		0x02
#define		IF_IRQ8		0x01
#define		IF_IRQ7		0x80
#define		IF_IRQ6		0x40
#define		IF_IRQ5		0x20
#define		IF_IRQ4		0x10
#define		IF_IRQ3		0x08
#define		IF_IRQ2		0x04
#define		IF_IRQ1		0x02
#define		IF_IRQ0		0x01 
//--------------------------------
#define		IF_SPI		0x80
#define		IF_MI2C		0x40
#define		IF_ADC		0x20
#define		IF_ACOMP	0x10
#define		IF_LVD		0x08
#define		IF_WTMR		0x04
#define		IF_ETMR		0x02
#define		IF_IN_TOG	0x01
//---------------------------------------------------------
*/
#define IE0_SPI_EN		DefineBit(rIE0_CTL, bit7)
#define IE0_MI2C_EN		DefineBit(rIE0_CTL, bit6)
#define IE0_ADC_EN		DefineBit(rIE0_CTL, bit5)
#define IE0_ACOMP_EN	DefineBit(rIE0_CTL, bit4)
#define IE0_LVD_EN		DefineBit(rIE0_CTL, bit3)
#define IE0_WTMR_EN		DefineBit(rIE0_CTL, bit2)
#define IE0_ETMR_EN		DefineBit(rIE0_CTL, bit1)
#define IE0_INTOG_EN	DefineBit(rIE0_CTL, bit0)

#define IE1_SPI_EN		DefineBit(rIE1_CTL, bit7)
#define IE1_MI2C_EN		DefineBit(rIE1_CTL, bit6)
#define IE1_ADC_EN		DefineBit(rIE1_CTL, bit5)
#define IE1_ACOMP_EN	DefineBit(rIE1_CTL, bit4)
#define IE1_LVD_EN		DefineBit(rIE1_CTL, bit3)
#define IE1_WTMR_EN		DefineBit(rIE1_CTL, bit2)
#define IE1_ETMR_EN		DefineBit(rIE1_CTL, bit1)
#define IE1_INTOG_EN	DefineBit(rIE1_CTL, bit0)

#define IE2_SPI_EN		DefineBit(rIE2_CTL, bit7)
#define IE2_MI2C_EN		DefineBit(rIE2_CTL, bit6)
#define IE2_ADC_EN		DefineBit(rIE2_CTL, bit5)
#define IE2_ACOMP_EN	DefineBit(rIE2_CTL, bit4)
#define IE2_LVD_EN		DefineBit(rIE2_CTL, bit3)
#define IE2_WTMR_EN		DefineBit(rIE2_CTL, bit2)
#define IE2_ETMR_EN		DefineBit(rIE2_CTL, bit1)
#define IE2_INTOG_EN	DefineBit(rIE2_CTL, bit0)

#define IE3_IRQ15_EN	DefineBit(rIE3_IRQH, bit7)
#define IE3_IRQ14_EN	DefineBit(rIE3_IRQH, bit6)
#define IE3_IRQ13_EN	DefineBit(rIE3_IRQH, bit5)
#define IE3_IRQ12_EN	DefineBit(rIE3_IRQH, bit4)
#define IE3_IRQ11_EN	DefineBit(rIE3_IRQH, bit3)
#define IE3_IRQ10_EN	DefineBit(rIE3_IRQH, bit2)
#define IE3_IRQ9_EN		DefineBit(rIE3_IRQH, bit1)
#define IE3_IRQ8_EN		DefineBit(rIE3_IRQH, bit0)
#define IE3_IRQ7_EN		DefineBit(rIE3_IRQL, bit7)
#define IE3_IRQ6_EN		DefineBit(rIE3_IRQL, bit6)
#define IE3_IRQ5_EN		DefineBit(rIE3_IRQL, bit5)
#define IE3_IRQ4_EN		DefineBit(rIE3_IRQL, bit4)
#define IE3_IRQ3_EN		DefineBit(rIE3_IRQL, bit3)
#define IE3_IRQ2_EN		DefineBit(rIE3_IRQL, bit2)
#define IE3_IRQ1_EN		DefineBit(rIE3_IRQL, bit1)
#define IE3_IRQ0_EN		DefineBit(rIE3_IRQL, bit0)

//--------------------------------
//	External IRQ Interrupt  --------- XFR_0x40 ~ XFR_0x49
//
//--------------------------------
//<1>:enable Ext_IRQxx
#define EXT_IRQ15_EN	DefineBit(rEN_IRQ_H, bit7)
#define EXT_IRQ14_EN	DefineBit(rEN_IRQ_H, bit6)
#define EXT_IRQ13_EN	DefineBit(rEN_IRQ_H, bit5)
#define EXT_IRQ12_EN	DefineBit(rEN_IRQ_H, bit4)
#define EXT_IRQ11_EN	DefineBit(rEN_IRQ_H, bit3)
#define EXT_IRQ10_EN	DefineBit(rEN_IRQ_H, bit2)
#define EXT_IRQ9_EN		DefineBit(rEN_IRQ_H, bit1)
#define EXT_IRQ8_EN		DefineBit(rEN_IRQ_H, bit0)
#define EXT_IRQ7_EN		DefineBit(rEN_IRQ_L, bit7)
#define EXT_IRQ6_EN		DefineBit(rEN_IRQ_L, bit6)
#define EXT_IRQ5_EN		DefineBit(rEN_IRQ_L, bit5)
#define EXT_IRQ4_EN		DefineBit(rEN_IRQ_L, bit4)
#define EXT_IRQ3_EN		DefineBit(rEN_IRQ_L, bit3)
#define EXT_IRQ2_EN		DefineBit(rEN_IRQ_L, bit2)
#define EXT_IRQ1_EN		DefineBit(rEN_IRQ_L, bit1)
#define EXT_IRQ0_EN		DefineBit(rEN_IRQ_L, bit0)

//<1>:IRQxx_Flag
#define EVT_IRQ15_EN	DefineBit(rEVT_IRQ_H, bit7)
#define EVT_IRQ14_EN	DefineBit(rEVT_IRQ_H, bit6)
#define EVT_IRQ13_EN	DefineBit(rEVT_IRQ_H, bit5)
#define EVT_IRQ12_EN	DefineBit(rEVT_IRQ_H, bit4)
#define EVT_IRQ11_EN	DefineBit(rEVT_IRQ_H, bit3)
#define EVT_IRQ10_EN	DefineBit(rEVT_IRQ_H, bit2)
#define EVT_IRQ9_EN		DefineBit(rEVT_IRQ_H, bit1)
#define EVT_IRQ8_EN		DefineBit(rEVT_IRQ_H, bit0)
#define EVT_IRQ7_EN		DefineBit(rEVT_IRQ_L, bit7)
#define EVT_IRQ6_EN		DefineBit(rEVT_IRQ_L, bit6)
#define EVT_IRQ5_EN		DefineBit(rEVT_IRQ_L, bit5)
#define EVT_IRQ4_EN		DefineBit(rEVT_IRQ_L, bit4)
#define EVT_IRQ3_EN		DefineBit(rEVT_IRQ_L, bit3)
#define EVT_IRQ2_EN		DefineBit(rEVT_IRQ_L, bit2)
#define EVT_IRQ1_EN		DefineBit(rEVT_IRQ_L, bit1)
#define EVT_IRQ0_EN		DefineBit(rEVT_IRQ_L, bit0)

//<1>:clear IRQxx_Flag
#define CLR_IRQ15_EN	DefineBit(rCLR_IRQ_H, bit7)
#define CLR_IRQ14_EN	DefineBit(rCLR_IRQ_H, bit6)
#define CLR_IRQ13_EN	DefineBit(rCLR_IRQ_H, bit5)
#define CLR_IRQ12_EN	DefineBit(rCLR_IRQ_H, bit4)
#define CLR_IRQ11_EN	DefineBit(rCLR_IRQ_H, bit3)
#define CLR_IRQ10_EN	DefineBit(rCLR_IRQ_H, bit2)
#define CLR_IRQ9_EN		DefineBit(rCLR_IRQ_H, bit1)
#define CLR_IRQ8_EN		DefineBit(rCLR_IRQ_H, bit0)
#define CLR_IRQ7_EN		DefineBit(rCLR_IRQ_L, bit7)
#define CLR_IRQ6_EN		DefineBit(rCLR_IRQ_L, bit6)
#define CLR_IRQ5_EN		DefineBit(rCLR_IRQ_L, bit5)
#define CLR_IRQ4_EN		DefineBit(rCLR_IRQ_L, bit4)
#define CLR_IRQ3_EN		DefineBit(rCLR_IRQ_L, bit3)
#define CLR_IRQ2_EN		DefineBit(rCLR_IRQ_L, bit2)
#define CLR_IRQ1_EN		DefineBit(rCLR_IRQ_L, bit1)
#define CLR_IRQ0_EN		DefineBit(rCLR_IRQ_L, bit0)

//<0/1>:BOTH/SINGLE -EDGE TRIGGER
#define EDGE0_IRQ15_EN		DefineBit(rIRQ_CHG_H, bit7)
#define EDGE0_IRQ14_EN		DefineBit(rIRQ_CHG_H, bit6)
#define EDGE0_IRQ13_EN		DefineBit(rIRQ_CHG_H, bit5)
#define EDGE0_IRQ12_EN		DefineBit(rIRQ_CHG_H, bit4)
#define EDGE0_IRQ11_EN		DefineBit(rIRQ_CHG_H, bit3)
#define EDGE0_IRQ10_EN		DefineBit(rIRQ_CHG_H, bit2)
#define EDGE0_IRQ9_EN		DefineBit(rIRQ_CHG_H, bit1)
#define EDGE0_IRQ8_EN		DefineBit(rIRQ_CHG_H, bit0)
#define EDGE0_IRQ7_EN		DefineBit(rIRQ_CHG_L, bit7)
#define EDGE0_IRQ6_EN		DefineBit(rIRQ_CHG_L, bit6)
#define EDGE0_IRQ5_EN		DefineBit(rIRQ_CHG_L, bit5)
#define EDGE0_IRQ4_EN		DefineBit(rIRQ_CHG_L, bit4)
#define EDGE0_IRQ3_EN		DefineBit(rIRQ_CHG_L, bit3)
#define EDGE0_IRQ2_EN		DefineBit(rIRQ_CHG_L, bit2)
#define EDGE0_IRQ1_EN		DefineBit(rIRQ_CHG_L, bit1)
#define EDGE0_IRQ0_EN		DefineBit(rIRQ_CHG_L, bit0)

//<0/1>:RISING/FALLING -EDGE TRIGGER, IF EDGE0 =1
#define EDGE1_IRQ15_EN		DefineBit(rIRQ_EDGE_H, bit7)
#define EDGE1_IRQ14_EN		DefineBit(rIRQ_EDGE_H, bit6)
#define EDGE1_IRQ13_EN		DefineBit(rIRQ_EDGE_H, bit5)
#define EDGE1_IRQ12_EN		DefineBit(rIRQ_EDGE_H, bit4)
#define EDGE1_IRQ11_EN		DefineBit(rIRQ_EDGE_H, bit3)
#define EDGE1_IRQ10_EN		DefineBit(rIRQ_EDGE_H, bit2)
#define EDGE1_IRQ9_EN		DefineBit(rIRQ_EDGE_H, bit1)
#define EDGE1_IRQ8_EN		DefineBit(rIRQ_EDGE_H, bit0)
#define EDGE1_IRQ7_EN		DefineBit(rIRQ_EDGE_L, bit7)
#define EDGE1_IRQ6_EN		DefineBit(rIRQ_EDGE_L, bit6)
#define EDGE1_IRQ5_EN		DefineBit(rIRQ_EDGE_L, bit5)
#define EDGE1_IRQ4_EN		DefineBit(rIRQ_EDGE_L, bit4)
#define EDGE1_IRQ3_EN		DefineBit(rIRQ_EDGE_L, bit3)
#define EDGE1_IRQ2_EN		DefineBit(rIRQ_EDGE_L, bit2)
#define EDGE1_IRQ1_EN		DefineBit(rIRQ_EDGE_L, bit1)
#define EDGE1_IRQ0_EN		DefineBit(rIRQ_EDGE_L, bit0)
//=====================================================================================
#endif